#!/usr/bin/python
# -*- coding:utf-8 -*-

"""NBA from yahoo.com
"""

from dom import *
import scorecard

def newInstance():
    return NBA_Yahoo_2005()


class NBA_Yahoo_2005 (scorecard.ScoreCard):
    def __init__( self ):
        self.games = []
        return

    """Overridable methods"""
    
    def getSportsCategory( self ):
        return "basketball"

    def getCountry( self ):
        return "USA"

    def getName( self ):
        return "NBA (Yahoo.com)"

    def getVersion( self ):
        return "1.0"

    def getIcon( self, team ):
        return ""

    def getEncoding( self ):
        return 'latin1'

    def getLanguage( self ):
        return "en"

    def decode( self, contents ):
        return contents
    #return unicode( contents, self.getEncoding() ).encode( 'utf-8' )
        
    def getURL( self ):
        return "http://sports.yahoo.com/nba/scoreboard/"

    def __read_game( self, elem_game ):
        game = None
        while elem_game != None:
            #print elem_game.get_text( ',' )
            if len( elem_game.get_children() ) >= 6:
                if game == None:
                    game = { 'team1':None, 'team2':None, 'status':'' }
                else:
                    #game[ 'team1' ] != None:
                    #game[ 'team1' ] = []
                    row = []
                    for child in elem_game.get_children():
                        if isinstance( child, Element ):
                            text = child.get_text()
                            if text != '': row.append( text )
                            pass
                        pass
                    if len( row ) > 1:
                        if game[ 'team2' ] != None:
                            break
                            pass
                        elif game[ 'team1' ] != None:
                            if len( row ) <= len( game[ 'team1' ] ):
                                game[ 'team2' ] = row
                                pass
                            else:
                                game[ 'status' ] += row[ -1 ]# + ' %d %d' % ( len( game[ 'team1' ] ), row )
                                game[ 'team2' ] = row[ 0: -1 ]
                                pass
                            pass
                        else:
                            game[ 'status' ] += row[ -1 ] + ' '
                            game[ 'team1' ] = row[ 0: -1 ]
                            pass
                        pass
                    pass
                pass
            try:
                elem_game = elem_game.next_sibling( 'tr' )
            except:
                break
            pass
        return game

    def __read_stats( self, elem ):
        import re
        players = []
        player = None
        for child in elem.get_children():
            if isinstance( child, Element ) == False: continue
            datum = child.get_element_at_path( 'td' )
            if datum == None: continue
            for d in datum.get_children():
                if isinstance( d, Text ):
                    if re.search( ":$", d.get_text() ):
                        player = { 'team': d.get_text()[ 0: -1 ], 'stats':'', 'name': '' }
                        players.append( player )
                        pass
                    else:
                        player[ 'stats' ] += d.get_text()
                        pass
                    pass
                if isinstance( d, Element ) and d.get_tagname() == 'a':
                    if re.match( '/nba/players', d.get_attribute( 'href' ) ):
                        player[ 'name' ] = d.get_text()
                        pass
                    pass
                pass
            if len( players ) >= 2: break
            pass
        return players


    def interpreteDocument( self, document ):
        import re, sys
        #elem = document.get_element_at_path( "/html/tr/td" ).get_first_child()
        #print elem
        #sys.exit()
        self.games = []
        elem_games = document.get_element_at_path( "/html/tr/td/table" )
        #print document
        while elem_games != None:
            elem_game = elem_games.get_element_at_path( 'tr' )
            #print "###########"
            game = self.__read_game( elem_game )
            if game != None:
                elem_games = elem_games.next_sibling( 'table' )
                players = self.__read_stats( elem_games )
                #print players
                if len( players ) >= 2:
                    game[ 'stats' ] = players
                    #game[ 'stats1' ] = players[ 0 ]
                    #game[ 'stats2' ] = players[ 1 ] ]
                    pass
                #sys.exit()
                #print elem_games.get_text( ',' )
                #sys.exit()
                #stats = self.__read_stats( elem_game )
                self.games.append( game )
                pass
            try:
                elem_games = elem_games.next_sibling( 'table' )
            except:
                break
            pass
        #print self.games
        #sys.exit()
        return

    def getStartKeyword( self ):
        return "class=\"ysptblclbg3\""

    def getEndKeyword( self ):
        return "<hr size="

    def toHTML( self ):
        """Format data into HTML.
        This method must be overridden."""
        html  = self.html_header()
        if len( self.games ) == 0:
            html += self.html_footer()
            return html

        for game in self.games:
            html += '<span class="tabletitle">%s</span>' % ( game[ 'status' ] )
            html += '<table>\n'
            for row in ( game[ 'team1' ], game[ 'team2' ] ):
                html += '<tr><td class="team">%s</td>' % row[ 0 ]
                n = 4 - len( row ) + 2
                for i in row[ 1: -1 ]:
                    html += '<td class="qt">%s</td>' % i
                    pass
                for i in range( 0, n ):
                    html += '<td class="qt"></td>'
                    pass
                html += '<td class="total">%s</td>' % row[ -1 ]
                html += '</tr>\n'
                pass
            html += '</table>'
            for stats in game[ 'stats' ]:
                html += '<div class="stats">'
                html += '<span class="statsteam">%s</span>&nbsp;' % stats[ 'team' ]
                html += '<span class="player">%s</span>&nbsp;' % stats[ 'name' ]
                html += '%s' % re.sub( ',', ' / ', stats[ 'stats' ] )
                html += '</div>\n'
            team1 = game[ 'team1' ]
            
            pass
        html += self.html_footer()
        return html
    
        for table in self.tables:
            try:
                title = table[ 'title' ]
                rows = table[ 'data' ]
                html += '<span class="tabletitle">%s</span>\n' % title
                html += '<table>\n'
                for row in rows:
                    html += '<tr>'
                    for i in range( min( len( self.headerclasses ), len( row ) ) ):
                        html += '<td class="%s">%s</td>' % ( self.headerclasses[ i ], row[ i ] )
                        pass
                    html += '</tr>\n'
                    pass
                html += '</table>\n'
            except:
                pass
            pass
        html += self.html_footer()
        return html

    def html_css_plugin( self ):
        return """<style type=\"text/css\">
        .qt { width:20px; height:20px; text-align:right;}
        .team {width:60px; height:20px; }
        .statsteam { width:50px; height:20px; padding-left:5px; }
        .player {font-family: \"HiraMaru-Pro\" \"Lucida Grande\"; font-size:10px; color:#008;font-weight:bold; padding:0px 4px 0px 4px;width:90px;}
        .stats { height:14px; font-family: \"HiraMaru-Pro\" \"Lucida Grande\"; font-size:10px;}
        .total {color:#c00;width:20px;height:20px;font-family: \"HiraMaru-Pro\" \"Lucida Grande\"; font-size:10px; padding:0px 4px 0px 10px;}
        </style>"""
        return ""
    pass


if __name__ == "__main__":
    """unit test"""
    filename_sample = None 
    import sys
    from loader import *

    if len( sys.argv ) > 1: filename_sample = sys.argv[ 1 ]
    
    obj = newInstance()

    if obj != None and obj.isAvailable():
        url = obj.getURL()
        if filename_sample:
            data = loadHTML_test( filename_sample )
        else:
            data = loadHTML( url )
            pass
        kw_start = obj.getStartKeyword()
        kw_end   = obj.getEndKeyword()
        parser = DOMConverter()
        if kw_start == None or kw_end == None:
            for line in data.split( "\n" ):
                parser.feed( obj.decode( line ) )
                pass
            pass
        else:
            flag_inside = False
            parser.feed( '<html>' )
            for line in re.split( "\n", data ):
                line = obj.decode( line.strip() )
                if flag_inside:
                    if line.count( kw_end ): flag_inside = False
                    else: parser.feed( line )
                elif line.count( kw_start ):
                    flag_inside = True
                    pass
                pass
            parser.feed( '</html>' )
            pass
        document = parser.get_document()
        obj.interpreteDocument( document )
        print obj.toHTML()
        pass
    pass
