#!/usr/bin/python
# -*- coding:utf-8 -*-

"""Sumo from nikkansports.com
"""

from dom import *
import scorecard

def newInstance():
    """This method must be inplemented in subclasses which instanciate
    an object."""
    return Sumo_NS_2005()


class Sumo_NS_2005 ( scorecard.ScoreCard ):
    def __init__( self ):
        scorecard.ScoreCard.__init__( self )
        #self.headerclasses = [ 'team', 'teamlogo', 'score', 'teamlogo', 'team', 'status' ]
        self.headerclasses = [ 'sekitori', 'hoshi', 'kimarite', 'hoshi', 'sekitori' ]
        return
    
    def getSportsCategory( self ):
        return "sumo"

    def getCountry( self ):
        return "Japan"

    def getName( self ):
        return "大相撲 (nikkansports.com)"

    def getVersion( self ):
        return "1.0"

    def getIcon( self, team ):
        return ""

    def getEncoding( self ):
        return 'sjis'

    def getLanguage( self ):
        return 'ja'

    def decode( self, contents ):
        return unicode( contents, 'sjis' ).encode( 'utf-8' )
        
    def getURL( self ):
        return "http://www.nikkansports.com/ns/sports/sumo/sm-score.html"

    def html_css_plugin( self ):
        css = """
        <style type=\"text/css\">
        .sekitori { margin:2px; text-align:center;width:70px; font-weight:bold;text-align:center;}
        .kimarite { text-align:center;width:60px;align:center;}
        .comment { font-size:9px; font-weight:normal;}
        .hoshi { text-align:center;width:24px;height:24px;}
        table tr td { margin-bottom:10px; height: 30px; border-bottom:1px solid gray;}
        </style>
        """
        return css

    def __hoshi( self, char ):
        import os, os.path
        dname = "file://" + os.path.abspath( os.path.curdir + "/../Images/" )
        if char == '○':
            return "<img src=\"%s/circle_white.png\">" % dname
        if char == '●':
            return "<img src=\"%s/circle_black.png\">" % dname
        return char
    
    def interpreteDocument( self, document ):
        import re, sys
        elem = document.get_element_at_path( "/html/table,2/tr/td/table" )
        title = elem.get_text( '&nbsp;&nbsp;' )
        table = { 'title':title, 'data':[] }
        elem_torikumi = elem.next_sibling( 'table' ).get_element_at_path( 'tr/td/table/tr' )
        #img_win = self.getIcon( 'win' )
        #img_lose = self.getIcon( 'lose' )
        while elem_torikumi != None:
            items = elem_torikumi.get_text( ',' ).split( ',' )
            if len( items ) >= 8:
                higashi    = items[ 0 ] 
                shouhai_h  = items[ 1 ]
                hoshi_h    = items[ 2 ]
                kimarite   = items[ 3 ]
                tm         = items[ 4 ]
                hoshi_n    = items[ 5 ]
                nishi      = items[ 6 ]
                shouhai_n  = items[ 7 ]

                c1 = higashi + '<br/><span class="comment">%s</span>' % shouhai_h
                c2 = self.__hoshi( hoshi_h )
                c3 = kimarite + '<br/><span class="comment">%s</span>' % tm
                c4 = self.__hoshi( hoshi_n )
                c5 = nishi + '<br/><span class="comment">%s</span>' % shouhai_n
                row = ( c1, c2, c3, c4, c5 )
                #row = ( higashi + '<br/>' + shouhai_h, hoshi_h, kimarite, hoshi_n, nishi + '<br/>' + shouhai_n, tm )
                table[ 'data' ].append( row )
                    
            try:
                elem_torikumi = elem_torikumi.next_sibling( 'tr' )
            except:
                break
            pass
        table[ 'data' ].reverse()
        self.tables = ( ( table, ) )

        return

    def getStartKeyword( self ):
        return "<!--====コンテンツエリア===-->"

    def getEndKeyword( self ):
        return "<!--====コンテンツエリア===-->"

    pass


